diff --git a/Novetus/NovetusCore/CharCustom/Forms/Compact/CharacterCustomizationCompact.cs b/Novetus/NovetusCore/CharCustom/Forms/Compact/CharacterCustomizationCompact.cs
index e23c996..0ec327b 100644
--- a/Novetus/NovetusCore/CharCustom/Forms/Compact/CharacterCustomizationCompact.cs
+++ b/Novetus/NovetusCore/CharCustom/Forms/Compact/CharacterCustomizationCompact.cs
@@ -12,420 +12,24 @@ using System.Windows.Forms;
 #region CharacterCustomization - Compact
 public partial class CharacterCustomizationCompact : Form
 {
-    #region Private Variables
-    private string SelectedPart = "Head";
-    private string Custom_T_Shirt_URL = "";
-    private string Custom_Shirt_URL = "";
-    private string Custom_Pants_URL = "";
-    private string Custom_Face_URL = "";
-    private List<VarStorage.PartColors> PartColorList;
-    private Settings.Provider[] contentProviders;
-    #endregion
-
     #region Constructor
     public CharacterCustomizationCompact()
     {
         InitializeComponent();
-        InitColors();
-    }
-
-    void InitColors()
-    {
-        PartColorList = new List<VarStorage.PartColors>()
-            {
-                //White
-                new VarStorage.PartColors{ ColorID = 1, ButtonColor = button7.BackColor },
-                //Light stone grey
-                new VarStorage.PartColors{ ColorID = 208, ButtonColor = button8.BackColor },
-                //Medium stone grey
-                new VarStorage.PartColors{ ColorID = 194, ButtonColor = button9.BackColor },
-                //Dark stone grey
-                new VarStorage.PartColors{ ColorID = 199, ButtonColor = button10.BackColor },
-                //Black
-                new VarStorage.PartColors{ ColorID = 26, ButtonColor = button14.BackColor },
-                //Bright red
-                new VarStorage.PartColors{ ColorID = 21, ButtonColor = button13.BackColor },
-                //Bright yellow
-                new VarStorage.PartColors{ ColorID = 24, ButtonColor = button12.BackColor },
-                //Cool yellow
-                new VarStorage.PartColors{ ColorID = 226, ButtonColor = button11.BackColor },
-                //Bright blue
-                new VarStorage.PartColors{ ColorID = 23, ButtonColor = button18.BackColor },
-                //Bright bluish green
-                new VarStorage.PartColors{ ColorID = 107, ButtonColor = button17.BackColor },
-                //Medium blue
-                new VarStorage.PartColors{ ColorID = 102, ButtonColor = button16.BackColor },
-                //Pastel Blue
-                new VarStorage.PartColors{ ColorID = 11, ButtonColor = button15.BackColor },
-                //Light blue
-                new VarStorage.PartColors{ ColorID = 45, ButtonColor = button22.BackColor },
-                //Sand blue
-                new VarStorage.PartColors{ ColorID = 135, ButtonColor = button21.BackColor },
-                //Bright orange
-                new VarStorage.PartColors{ ColorID = 106, ButtonColor = button20.BackColor },
-                //Br. yellowish orange
-                new VarStorage.PartColors{ ColorID = 105, ButtonColor = button19.BackColor },
-                //Earth green
-                new VarStorage.PartColors{ ColorID = 141, ButtonColor = button26.BackColor },
-                //Dark green
-                new VarStorage.PartColors{ ColorID = 28, ButtonColor = button25.BackColor },
-                //Bright green
-                new VarStorage.PartColors{ ColorID = 37, ButtonColor = button24.BackColor },
-                //Br. yellowish green
-                new VarStorage.PartColors{ ColorID = 119, ButtonColor = button23.BackColor },
-                //Medium green
-                new VarStorage.PartColors{ ColorID = 29, ButtonColor = button30.BackColor },
-                //Sand green
-                new VarStorage.PartColors{ ColorID = 151, ButtonColor = button29.BackColor },
-                //Dark orange
-                new VarStorage.PartColors{ ColorID = 38, ButtonColor = button28.BackColor },
-                //Reddish brown
-                new VarStorage.PartColors{ ColorID = 192, ButtonColor = button27.BackColor },
-                //Bright violet
-                new VarStorage.PartColors{ ColorID = 104, ButtonColor = button34.BackColor },
-                //Light reddish violet
-                new VarStorage.PartColors{ ColorID = 9, ButtonColor = button33.BackColor },
-                //Medium red
-                new VarStorage.PartColors{ ColorID = 101, ButtonColor = button32.BackColor },
-                //Brick yellow
-                new VarStorage.PartColors{ ColorID = 5, ButtonColor = button31.BackColor },
-                //Sand red
-                new VarStorage.PartColors{ ColorID = 153, ButtonColor = button38.BackColor },
-                //Brown
-                new VarStorage.PartColors{ ColorID = 217, ButtonColor = button37.BackColor },
-                //Nougat
-                new VarStorage.PartColors{ ColorID = 18, ButtonColor = button36.BackColor },
-                //Light orange
-                new VarStorage.PartColors{ ColorID = 125, ButtonColor = button35.BackColor },
-                // RARE 2006 COLORS!!
-                //Med. reddish violet
-                new VarStorage.PartColors{ ColorID = 22, ButtonColor = button69.BackColor },
-                //Dark nougat
-                new VarStorage.PartColors{ ColorID = 128, ButtonColor = button70.BackColor }
-            };
+        InitCompactForm();
+        characterCustomizationForm.InitColors();
     }
     #endregion
 
     #region Form Events
     void CharacterCustomizationLoad(object sender, EventArgs e)
     {
-        if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
-        {
-            contentProviders = Settings.OnlineClothing.GetContentProviders();
-
-            for (int i = 0; i < contentProviders.Length; i++)
-            {
-                FaceTypeBox.Items.Add(contentProviders[i].Name);
-                TShirtsTypeBox.Items.Add(contentProviders[i].Name);
-                ShirtsTypeBox.Items.Add(contentProviders[i].Name);
-                PantsTypeBox.Items.Add(contentProviders[i].Name);
-            }
-
-            //face
-            if (GlobalVars.UserCustomization.Face.Contains("http://"))
-            {
-                Settings.Provider faceProvider = Settings.OnlineClothing.FindContentProviderByURL(contentProviders, GlobalVars.UserCustomization.Face);
-                FaceIDBox.Text = GlobalVars.UserCustomization.Face.Replace(faceProvider.URL, "");
-                FaceTypeBox.SelectedItem = faceProvider.Name;
-            }
-
-            //clothing
-            if (GlobalVars.UserCustomization.TShirt.Contains("http://"))
-            {
-                Settings.Provider tShirtProvider = Settings.OnlineClothing.FindContentProviderByURL(contentProviders, GlobalVars.UserCustomization.TShirt);
-                TShirtsIDBox.Text = GlobalVars.UserCustomization.TShirt.Replace(tShirtProvider.URL, "");
-                TShirtsTypeBox.SelectedItem = tShirtProvider.Name;
-            }
-
-            if (GlobalVars.UserCustomization.Shirt.Contains("http://"))
-            {
-                Settings.Provider shirtProvider = Settings.OnlineClothing.FindContentProviderByURL(contentProviders, GlobalVars.UserCustomization.Shirt);
-                ShirtsIDBox.Text = GlobalVars.UserCustomization.Shirt.Replace(shirtProvider.URL, "");
-                ShirtsTypeBox.SelectedItem = shirtProvider.Name;
-            }
-
-            if (GlobalVars.UserCustomization.Pants.Contains("http://"))
-            {
-                Settings.Provider pantsProvider = Settings.OnlineClothing.FindContentProviderByURL(contentProviders, GlobalVars.UserCustomization.Pants);
-                PantsIDBox.Text = GlobalVars.UserCustomization.Pants.Replace(pantsProvider.URL, "");
-                PantsTypeBox.SelectedItem = pantsProvider.Name;
-            }
-        }
-        else
-        {
-            FaceTypeBox.Enabled = false;
-            TShirtsTypeBox.Enabled = false;
-            ShirtsTypeBox.Enabled = false;
-            PantsTypeBox.Enabled = false;
-            FaceIDBox.Enabled = false;
-            TShirtsIDBox.Enabled = false;
-            ShirtsIDBox.Enabled = false;
-            PantsIDBox.Enabled = false;
-        }
-
-        //body
-        label2.Text = SelectedPart;
-        button1.BackColor = ConvertStringtoColor(GlobalVars.UserCustomization.HeadColorString);
-        button2.BackColor = ConvertStringtoColor(GlobalVars.UserCustomization.TorsoColorString);
-        button3.BackColor = ConvertStringtoColor(GlobalVars.UserCustomization.RightArmColorString);
-        button4.BackColor = ConvertStringtoColor(GlobalVars.UserCustomization.LeftArmColorString);
-        button5.BackColor = ConvertStringtoColor(GlobalVars.UserCustomization.RightLegColorString);
-        button6.BackColor = ConvertStringtoColor(GlobalVars.UserCustomization.LeftLegColorString);
-
-        //icon
-        label5.Text = GlobalVars.UserCustomization.Icon;
-
-        //charid
-        textBox1.Text = GlobalVars.UserCustomization.CharacterID;
-
-        checkBox1.Checked = GlobalVars.UserCustomization.ShowHatsInExtra;
-
-        //discord
-        GlobalFuncs.UpdateRichPresence(GlobalVars.LauncherState.InCustomization, GlobalVars.UserConfiguration.Map);
-
-        GlobalFuncs.ReloadLoadoutValue();
+        characterCustomizationForm.InitForm();
     }
 
     void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
     {
-        switch (tabControl1.SelectedTab)
-        {
-            case TabPage pg1 when pg1 == tabControl1.TabPages["tabPage1"]:
-
-                listBox1.Items.Clear();
-                listBox2.Items.Clear();
-                listBox3.Items.Clear();
-                listBox4.Items.Clear();
-                listBox5.Items.Clear();
-                listBox6.Items.Clear();
-                listBox7.Items.Clear();
-                listBox8.Items.Clear();
-                listBox9.Items.Clear();
-                break;
-            case TabPage pg7 when pg7 == tabControl1.TabPages["tabPage7"]:
-
-                listBox1.Items.Clear();
-                listBox2.Items.Clear();
-                listBox3.Items.Clear();
-                listBox4.Items.Clear();
-                listBox5.Items.Clear();
-                listBox6.Items.Clear();
-                listBox7.Items.Clear();
-                listBox8.Items.Clear();
-                listBox9.Items.Clear();
-
-                Image icon1 = CustomizationFuncs.LoadImage(GlobalPaths.extradirIcons + "\\" + GlobalVars.UserConfiguration.PlayerName + ".png", GlobalPaths.extradir + "\\NoExtra.png");
-                pictureBox10.Image = icon1;
-
-                break;
-            case TabPage pg2 when pg2 == tabControl1.TabPages["tabPage2"]:
-                //hats
-
-                listBox4.Items.Clear();
-                listBox5.Items.Clear();
-                listBox6.Items.Clear();
-                listBox7.Items.Clear();
-                listBox8.Items.Clear();
-                listBox9.Items.Clear();
-
-                CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.Hat1,
-                        GlobalPaths.hatdir,
-                        "NoHat",
-                        pictureBox1,
-                        textBox2,
-                        listBox1,
-                        true
-                    );
-
-                CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.Hat2,
-                        GlobalPaths.hatdir,
-                        "NoHat",
-                        pictureBox2,
-                        textBox3,
-                        listBox2,
-                        true
-                    );
-
-                CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.Hat3,
-                        GlobalPaths.hatdir,
-                        "NoHat",
-                        pictureBox3,
-                        textBox4,
-                        listBox3,
-                        true
-                    );
-
-                break;
-            case TabPage pg3 when pg3 == tabControl1.TabPages["tabPage3"]:
-                //faces
-
-                listBox1.Items.Clear();
-                listBox2.Items.Clear();
-                listBox3.Items.Clear();
-                listBox5.Items.Clear();
-                listBox6.Items.Clear();
-                listBox7.Items.Clear();
-                listBox8.Items.Clear();
-                listBox9.Items.Clear();
-
-                CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.Face,
-                        GlobalPaths.facedir,
-                        "DefaultFace",
-                        pictureBox4,
-                        textBox6,
-                        listBox4,
-                        true,
-                        FaceTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, FaceTypeBox.SelectedItem.ToString()) : null
-                    );
-
-                break;
-            case TabPage pg4 when pg4 == tabControl1.TabPages["tabPage4"]:
-                //faces
-
-                listBox1.Items.Clear();
-                listBox2.Items.Clear();
-                listBox3.Items.Clear();
-                listBox4.Items.Clear();
-                listBox6.Items.Clear();
-                listBox7.Items.Clear();
-                listBox8.Items.Clear();
-                listBox9.Items.Clear();
-
-                CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.TShirt,
-                        GlobalPaths.tshirtdir,
-                        "NoTShirt",
-                        pictureBox5,
-                        textBox7,
-                        listBox5,
-                        true,
-                        TShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, TShirtsTypeBox.SelectedItem.ToString()) : null
-                    );
-
-                break;
-            case TabPage pg5 when pg5 == tabControl1.TabPages["tabPage5"]:
-                //faces
-
-                listBox1.Items.Clear();
-                listBox2.Items.Clear();
-                listBox3.Items.Clear();
-                listBox4.Items.Clear();
-                listBox5.Items.Clear();
-                listBox7.Items.Clear();
-                listBox8.Items.Clear();
-                listBox9.Items.Clear();
-
-                CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.Shirt,
-                        GlobalPaths.shirtdir,
-                        "NoShirt",
-                        pictureBox6,
-                        textBox8,
-                        listBox6,
-                        true,
-                        ShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, ShirtsTypeBox.SelectedItem.ToString()) : null
-                    );
-
-                break;
-            case TabPage pg6 when pg6 == tabControl1.TabPages["tabPage6"]:
-                //faces
-
-                listBox1.Items.Clear();
-                listBox2.Items.Clear();
-                listBox3.Items.Clear();
-                listBox4.Items.Clear();
-                listBox5.Items.Clear();
-                listBox6.Items.Clear();
-                listBox8.Items.Clear();
-                listBox9.Items.Clear();
-
-                CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.Pants,
-                        GlobalPaths.pantsdir,
-                        "NoPants",
-                        pictureBox7,
-                        textBox9,
-                        listBox7,
-                        true,
-                        PantsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, PantsTypeBox.SelectedItem.ToString()) : null
-                    );
-
-                break;
-            case TabPage pg8 when pg8 == tabControl1.TabPages["tabPage8"]:
-                //faces
-
-                listBox1.Items.Clear();
-                listBox2.Items.Clear();
-                listBox3.Items.Clear();
-                listBox4.Items.Clear();
-                listBox5.Items.Clear();
-                listBox6.Items.Clear();
-                listBox7.Items.Clear();
-                listBox9.Items.Clear();
-
-                CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.Head,
-                        GlobalPaths.headdir,
-                        "DefaultHead",
-                        pictureBox8,
-                        textBox5,
-                        listBox8,
-                        true
-                    );
-
-                break;
-            case TabPage pg9 when pg9 == tabControl1.TabPages["tabPage9"]:
-                //faces
-
-                listBox1.Items.Clear();
-                listBox2.Items.Clear();
-                listBox3.Items.Clear();
-                listBox4.Items.Clear();
-                listBox5.Items.Clear();
-                listBox6.Items.Clear();
-                listBox7.Items.Clear();
-                listBox8.Items.Clear();
-
-                CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.Extra,
-                        GlobalPaths.extradir,
-                        "NoExtra",
-                        pictureBox9,
-                        textBox10,
-                        listBox9,
-                        true
-                    );
-
-                if (GlobalVars.UserCustomization.ShowHatsInExtra)
-                {
-                    CustomizationFuncs.ChangeItem(
-                        GlobalVars.UserCustomization.Extra,
-                        GlobalPaths.hatdir,
-                        "NoHat",
-                        pictureBox9,
-                        textBox10,
-                        listBox9,
-                        true,
-                        GlobalVars.UserCustomization.ShowHatsInExtra
-                    );
-                }
-                break;
-            default:
-                listBox1.Items.Clear();
-                listBox2.Items.Clear();
-                listBox3.Items.Clear();
-                listBox4.Items.Clear();
-                listBox5.Items.Clear();
-                listBox6.Items.Clear();
-                listBox7.Items.Clear();
-                listBox8.Items.Clear();
-                listBox9.Items.Clear();
-                break;
-        }
+        characterCustomizationForm.ChangeTabs();
     }
 
     void CharacterCustomizationClose(object sender, CancelEventArgs e)
@@ -531,7 +135,7 @@ public partial class CharacterCustomizationCompact : Form
                 FaceIDBox.Text = "";
                 if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
                 {
-                    FaceTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                    FaceTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
                 }
             }
             listBox4.SelectedItem = previtem;
@@ -545,7 +149,7 @@ public partial class CharacterCustomizationCompact : Form
                             textBox6,
                             listBox4,
                             false,
-                            FaceTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, FaceTypeBox.SelectedItem.ToString()) : null
+                            FaceTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(characterCustomizationForm.contentProviders, FaceTypeBox.SelectedItem.ToString()) : null
                         );
         }
     }
@@ -557,7 +161,7 @@ public partial class CharacterCustomizationCompact : Form
             FaceIDBox.Text = "";
             if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
             {
-                FaceTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                FaceTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
             }
             Random random = new Random();
             int randomFace1 = random.Next(listBox4.Items.Count);
@@ -572,7 +176,7 @@ public partial class CharacterCustomizationCompact : Form
             FaceIDBox.Text = "";
             if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
             {
-                FaceTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                FaceTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
             }
             listBox4.SelectedItem = "DefaultFace.rbxm";
         }
@@ -584,7 +188,7 @@ public partial class CharacterCustomizationCompact : Form
 
         if (!string.IsNullOrWhiteSpace(FaceIDBox.Text))
         {
-            GlobalVars.UserCustomization.Face = Custom_Face_URL + FaceIDBox.Text;
+            GlobalVars.UserCustomization.Face = characterCustomizationForm.Custom_Face_URL + FaceIDBox.Text;
             FaceIDBox.Focus();
         }
         else
@@ -600,7 +204,7 @@ public partial class CharacterCustomizationCompact : Form
                             textBox6,
                             listBox4,
                             false,
-                            FaceTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, FaceTypeBox.SelectedItem.ToString()) : null
+                            FaceTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(characterCustomizationForm.contentProviders, FaceTypeBox.SelectedItem.ToString()) : null
                         );
     }
 
@@ -610,13 +214,13 @@ public partial class CharacterCustomizationCompact : Form
 
         if (FaceTypeBox.SelectedItem != null)
         {
-            faceProvider = Settings.OnlineClothing.FindContentProviderByName(contentProviders, FaceTypeBox.SelectedItem.ToString());
-            Custom_Face_URL = faceProvider.URL;
+            faceProvider = Settings.OnlineClothing.FindContentProviderByName(characterCustomizationForm.contentProviders, FaceTypeBox.SelectedItem.ToString());
+            characterCustomizationForm.Custom_Face_URL = faceProvider.URL;
         }
 
         if (!string.IsNullOrWhiteSpace(FaceIDBox.Text))
         {
-            GlobalVars.UserCustomization.Face = Custom_Face_URL + FaceIDBox.Text;
+            GlobalVars.UserCustomization.Face = characterCustomizationForm.Custom_Face_URL + FaceIDBox.Text;
             CustomizationFuncs.ChangeItem(
                             GlobalVars.UserCustomization.Face,
                             GlobalPaths.facedir,
@@ -644,7 +248,7 @@ public partial class CharacterCustomizationCompact : Form
                 TShirtsIDBox.Text = "";
                 if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
                 {
-                    TShirtsTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                    TShirtsTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
                 }
             }
             listBox5.SelectedItem = previtem;
@@ -658,7 +262,7 @@ public partial class CharacterCustomizationCompact : Form
                         textBox7,
                         listBox5,
                         false,
-                        TShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, TShirtsTypeBox.SelectedItem.ToString()) : null
+                        TShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(characterCustomizationForm.contentProviders, TShirtsTypeBox.SelectedItem.ToString()) : null
                     );
         }
     }
@@ -670,7 +274,7 @@ public partial class CharacterCustomizationCompact : Form
             TShirtsIDBox.Text = "";
             if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
             {
-                TShirtsTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                TShirtsTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
             }
             Random random = new Random();
             int randomTShirt1 = random.Next(listBox5.Items.Count);
@@ -685,7 +289,7 @@ public partial class CharacterCustomizationCompact : Form
             TShirtsIDBox.Text = "";
             if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
             {
-                TShirtsTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                TShirtsTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
             }
             listBox5.SelectedItem = "NoTShirt.rbxm";
         }
@@ -697,7 +301,7 @@ public partial class CharacterCustomizationCompact : Form
 
         if (!string.IsNullOrWhiteSpace(TShirtsIDBox.Text))
         {
-            GlobalVars.UserCustomization.TShirt = Custom_T_Shirt_URL + TShirtsIDBox.Text;
+            GlobalVars.UserCustomization.TShirt = characterCustomizationForm.Custom_T_Shirt_URL + TShirtsIDBox.Text;
             TShirtsIDBox.Focus();
         }
         else
@@ -713,7 +317,7 @@ public partial class CharacterCustomizationCompact : Form
                             textBox7,
                             listBox5,
                             false,
-                            TShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, TShirtsTypeBox.SelectedItem.ToString()) : null
+                            TShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(characterCustomizationForm.contentProviders, TShirtsTypeBox.SelectedItem.ToString()) : null
                         );
     }
 
@@ -723,13 +327,13 @@ public partial class CharacterCustomizationCompact : Form
 
         if (TShirtsTypeBox.SelectedItem != null)
         {
-            tShirtProvider = Settings.OnlineClothing.FindContentProviderByName(contentProviders, TShirtsTypeBox.SelectedItem.ToString());
-            Custom_T_Shirt_URL = tShirtProvider.URL;
+            tShirtProvider = Settings.OnlineClothing.FindContentProviderByName(characterCustomizationForm.contentProviders, TShirtsTypeBox.SelectedItem.ToString());
+            characterCustomizationForm.Custom_T_Shirt_URL = tShirtProvider.URL;
         }
 
         if (!string.IsNullOrWhiteSpace(TShirtsIDBox.Text))
         {
-            GlobalVars.UserCustomization.TShirt = Custom_T_Shirt_URL + TShirtsIDBox.Text;
+            GlobalVars.UserCustomization.TShirt = characterCustomizationForm.Custom_T_Shirt_URL + TShirtsIDBox.Text;
             CustomizationFuncs.ChangeItem(
                             GlobalVars.UserCustomization.TShirt,
                             GlobalPaths.tshirtdir,
@@ -756,7 +360,7 @@ public partial class CharacterCustomizationCompact : Form
                 ShirtsIDBox.Text = "";
                 if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
                 {
-                    ShirtsTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                    ShirtsTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
                 }
             }
             listBox6.SelectedItem = previtem;
@@ -770,7 +374,7 @@ public partial class CharacterCustomizationCompact : Form
                         textBox8,
                         listBox6,
                         false,
-                        ShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, ShirtsTypeBox.SelectedItem.ToString()) : null
+                        ShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(characterCustomizationForm.contentProviders, ShirtsTypeBox.SelectedItem.ToString()) : null
                     );
         }
     }
@@ -782,7 +386,7 @@ public partial class CharacterCustomizationCompact : Form
             ShirtsIDBox.Text = "";
             if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
             {
-                ShirtsTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                ShirtsTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
             }
             Random random = new Random();
             int randomShirt1 = random.Next(listBox6.Items.Count);
@@ -797,7 +401,7 @@ public partial class CharacterCustomizationCompact : Form
             ShirtsIDBox.Text = "";
             if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
             {
-                ShirtsTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                ShirtsTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
             }
             listBox6.SelectedItem = "NoShirt.rbxm";
         }
@@ -809,7 +413,7 @@ public partial class CharacterCustomizationCompact : Form
 
         if (!string.IsNullOrWhiteSpace(ShirtsIDBox.Text))
         {
-            GlobalVars.UserCustomization.Shirt = Custom_Shirt_URL + ShirtsIDBox.Text;
+            GlobalVars.UserCustomization.Shirt = characterCustomizationForm.Custom_Shirt_URL + ShirtsIDBox.Text;
             ShirtsIDBox.Focus();
         }
         else
@@ -825,7 +429,7 @@ public partial class CharacterCustomizationCompact : Form
                             textBox8,
                             listBox6,
                             false,
-                            ShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(contentProviders, ShirtsTypeBox.SelectedItem.ToString()) : null
+                            ShirtsTypeBox.SelectedItem != null ? Settings.OnlineClothing.FindContentProviderByName(characterCustomizationForm.contentProviders, ShirtsTypeBox.SelectedItem.ToString()) : null
                         );
     }
 
@@ -835,13 +439,13 @@ public partial class CharacterCustomizationCompact : Form
 
         if (ShirtsTypeBox.SelectedItem != null)
         {
-            shirtProvider = Settings.OnlineClothing.FindContentProviderByName(contentProviders, ShirtsTypeBox.SelectedItem.ToString());
-            Custom_Shirt_URL = shirtProvider.URL;
+            shirtProvider = Settings.OnlineClothing.FindContentProviderByName(characterCustomizationForm.contentProviders, ShirtsTypeBox.SelectedItem.ToString());
+            characterCustomizationForm.Custom_Shirt_URL = shirtProvider.URL;
         }
 
         if (!string.IsNullOrWhiteSpace(ShirtsIDBox.Text))
         {
-            GlobalVars.UserCustomization.Shirt = Custom_Shirt_URL + ShirtsIDBox.Text;
+            GlobalVars.UserCustomization.Shirt = characterCustomizationForm.Custom_Shirt_URL + ShirtsIDBox.Text;
             CustomizationFuncs.ChangeItem(
                             GlobalVars.UserCustomization.Shirt,
                             GlobalPaths.shirtdir,
@@ -868,7 +472,7 @@ public partial class CharacterCustomizationCompact : Form
                 PantsIDBox.Text = "";
                 if (File.Exists(GlobalPaths.ConfigDir + "\\ContentProviders.xml"))
                 {
-                    PantsTypeBox.SelectedItem = contentProviders.FirstOrDefault().Name;
+                    PantsTypeBox.SelectedItem = characterCustomizationForm.contentProviders.FirstOrDefault().Name;
                 }
             }
             listBox7.SelectedItem = previtem;
